<div id="body" class="container-fluid">
  <h6 class="mb-1">{{ title }} Order</h6>
  <h6 class="text-danger" *ngIf="locked">{{ lblError }}</h6>
  <form [formGroup]="form" novalidate>
    <div class="form-row text-center">
      <div class="form-group form-group-sm col-3">
        <button type="button" class="btn btn-sm btn-secondary btn-block" (click)="cancel()">
          Cancel / Close
        </button>
      </div>
      <div *ngIf="!isOrderComplete && !isClosed && !isReadonly" class="form-group form-group-sm col-3">
        <button type="button" class="btn btn-sm btn-primary btn-block" (click)="submit()" [disabled]="locked">
          Save
        </button>
      </div>
      <div *ngIf="!isOrderComplete && showCPE && !isReadonly" class="form-group form-group-sm col-3">
        <button type="button" class="btn btn-sm btn-primary btn-block" (click)="completeCpe()" [disabled]="locked">
          Complete/Close
        </button>
      </div>
      <div *ngIf="!isOrderComplete && showReturnToGomButton && !isReadonly" class="form-group form-group-sm col-3">
        <button type="button" class="btn btn-sm btn-primary btn-block" (click)="returnToGom()" [disabled]="locked">
          Return to GOM
        </button>
      </div>
      <div *ngIf="!isOrderComplete && (!isClosed && showReturnToSalesButton) && !isReadonly" class="form-group form-group-sm col-3">
        <button type="button" class="btn btn-sm btn-primary btn-block" (click)="returnToSales()" [disabled]="locked">
          Return to Sales
        </button>
      </div>
      <div *ngIf="!isOrderComplete && showClearAcr && !isReadonly" class="form-group form-group-sm col-3">
        <button type="button" class="btn btn-sm btn-primary btn-block" (click)="clearAcrTask()" [disabled]="locked">
          Clear ACR Notification
        </button>
      </div>
      <div *ngIf="!isOrderComplete && showClearRts && !isReadonly" class="form-group form-group-sm col-3">
        <button type="button" class="btn btn-sm btn-primary btn-block" (click)="clearAcrTask()" [disabled]="locked">
          Clear RTS Response Notification
        </button>
      </div>
      <div *ngIf="showClearCcd && !isReadonly" class="form-group form-group-sm col-3">
        <button type="button" class="btn btn-sm btn-primary btn-block" (click)="clearAcrTask()" [disabled]="locked">
          Clear CCD Notification
        </button>
      </div>
      <div *ngIf="!isOrderComplete && showSalesSupportNotes && !isReadonly" class="form-group form-group-sm col-3">
        <button type="button" class="btn btn-sm btn-primary btn-block" (click)="salesSupportNotes()">
          Sales Support Notes
        </button>
      </div>
      <div *ngIf="showRequestToLogicallis && !isReadonly" class="form-group form-group-sm col-3">
        <button type="button" class="btn btn-sm btn-primary btn-block" (click)="showRequestToLogicallisForm()">
          Request to Logicallis
        </button>
      </div>
      <div *ngIf="isBAREditAllowed" class="form-group form-group-sm col-3">
        <button type="button" class="btn btn-sm btn-primary btn-block" (click)="editOrder()">
          Edit Order
        </button>
      </div>
    </div>
    <!-- NCCO Details -->
    <mat-accordion *ngIf="showNCCO">
      <mat-expansion-panel [expanded]="true" class="mb-2">
        <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
          <mat-panel-title><h6>NCCO Details</h6></mat-panel-title>
        </mat-expansion-panel-header>
        <app-ncco-order-details [group]="form.controls.nccoOrderDetails" [showEditButton]="false"></app-ncco-order-details>
      </mat-expansion-panel>
    </mat-accordion>
    <!-- M5 Details -->
    <mat-accordion *ngIf="showFSA">
      <mat-expansion-panel [expanded]="true" class="mb-2">
        <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
          <mat-panel-title><h6>M5 # Details</h6></mat-panel-title>
        </mat-expansion-panel-header>
        <!-- <dx-data-grid [dataSource]="m5DetailList"
                    [wordWrapEnabled]="true" [rowAlternationEnabled]="true"
                    [showBorders]="true" [columnAutoWidth]="true">
        <dxo-sorting mode="multiple"></dxo-sorting>
        <dxo-column-fixing [enabled]="true"></dxo-column-fixing>
        <dxo-scrolling mode="standard" useNative="false"></dxo-scrolling>

        <dxi-column dataField="ftn" caption="M5 #" dataType="string" cellTemplate="m5LinkTemplate"></dxi-column>
        <dxi-column dataField="cusT_NME" caption="Customer Name" dataType="string"></dxi-column>
        <dxi-column dataField="ordR_TYPE" caption="Order Type" dataType="string"></dxi-column>
        <dxi-column dataField="ordR_SUB_TYPE" caption="Order Sub Type" dataType="string"></dxi-column>
        <dxi-column dataField="proD_TYPE" caption="Product Type" dataType="string"></dxi-column>
        <dxi-column dataField="ordR_STUS_DES" caption="Order Status" dataType="string"></dxi-column>
        <dxi-column dataField="acT_TASK" caption="Pending Tasks" dataType="string" cellTemplate="taskTemplate"></dxi-column>
        <div *dxTemplate="let cell of 'm5LinkTemplate'">
          <a href="#" (click)="onM5Clicked($event, cell.data)">{{ cell.text }}</a>
        </div>
        <div *dxTemplate="let cell of 'taskTemplate'">
          <span class="d-block" *ngFor="let value of cell.value?.split(',')">
            {{ value }}
          </span>
        </div>
      </dx-data-grid> -->

        <div class="form-row" formGroupName="display">
          <!--ROW 1-->
          <div class="form-group form-group-sm row col-24">
            <label class="col-form-label col col-lg-4 pr-1 text-right">M5 #:</label>
            <div class="col col-lg-4 pl-0 pl-lg-1">
              <label class="hyperlink" (click)="onM5Clicked($event, m5Data)"> {{ m5 }} </label>
            </div>
            <label class="col-form-label col col-lg-4 pr-1 text-right">Pending Tasks:</label>
            <div class="col col-lg-12 pl-0 pl-lg-1">
              <input type="text" readonly class="form-control form-control-sm" formControlName="pendingTasks" />
            </div>
          </div>
          <!--ROW 2-->
          <div class="form-group form-group-sm row col-24">
            <label class="col-form-label col col-lg-4 pr-1 text-right">Order Status:</label>
            <div class="col col-lg-4 pl-0 pl-lg-1">
              <input type="text" readonly class="form-control form-control-sm" formControlName="orderStatus" />
            </div>
            <label class="col-form-label col col-lg-4 pr-1 text-right">Order Type:</label>
            <div class="col col-lg-4 pl-0 pl-lg-1">
              <input type="text" readonly class="form-control form-control-sm" formControlName="orderType" />
            </div>
            <label class="col-form-label col col-lg-4 pr-1 text-right">Order Sub Type:</label>
            <div class="col col-lg-4 pl-0 pl-lg-1">
              <input type="text" readonly class="form-control form-control-sm" formControlName="orderSubType" />
            </div>
          </div>
          <!--ROW 3-->
          <div class="form-group form-group-sm row col-24">
            <label class="col-form-label col col-lg-4 pr-1 text-right">Product Type:</label>
            <div class="col col-lg-4 pl-0 pl-lg-1">
              <input type="text" readonly class="form-control form-control-sm" formControlName="productType" />
            </div>
            <label class="col-form-label col col-lg-4 pr-1 text-right">Customer Name:</label>
            <div class="col col-lg-4 pl-0 pl-lg-1">
              <input type="text" readonly class="form-control form-control-sm" formControlName="customerName" />
            </div>
            <label class="col-form-label col col-lg-4 pr-1 text-right">Customer Name (H1):</label>
            <div class="col col-lg-4 pl-0 pl-lg-1">
              <input type="text" readonly class="form-control form-control-sm" formControlName="customerNameH1" />
            </div>
          </div>
          <!--ROW 4-->
          <div class="form-group form-group-sm row col-24">
            <label class="col-form-label col col-lg-4 pr-1 text-right">H6 Address Line 1:</label>
            <div class="col col-lg-4 pl-0 pl-lg-1">
              <input type="text" readonly class="form-control form-control-sm" formControlName="h6AddressLine1" />
            </div>
            <label class="col-form-label col col-lg-4 pr-1 text-right">H6 City:</label>
            <div class="col col-lg-4 pl-0 pl-lg-1">
              <input type="text" readonly class="form-control form-control-sm" formControlName="h6City" />
            </div>
            <label class="col-form-label col col-lg-4 pr-1 text-right">H6 Country:</label>
            <div class="col col-lg-4 pl-0 pl-lg-1">
              <input type="text" readonly class="form-control form-control-sm" formControlName="h6Country" />
            </div>
          </div>
          <!--ROW 5-->
          <div class="form-group form-group-sm row col-24">
            <label class="col-form-label col col-lg-4 pr-1 text-right">Vendor Name:</label>
            <div class="col col-lg-4 pl-0 pl-lg-1">
              <input type="text" readonly class="form-control form-control-sm" formControlName="vendorName" />
            </div>
            <label class="col-form-label col col-lg-4 pr-1 text-right">Access Bandwidth:</label>
            <div class="col col-lg-4 pl-0 pl-lg-1">
              <input type="text" readonly class="form-control form-control-sm" formControlName="accessBandwidth" />
            </div>
          </div>
        </div>


      </mat-expansion-panel>
    </mat-accordion>
    <!-- Order Milestone -->
    <mat-accordion *ngIf="!showCPE">
      <mat-expansion-panel [expanded]="true" class="mb-2">
        <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
          <mat-panel-title><h6>Order Milestones</h6></mat-panel-title>
        </mat-expansion-panel-header>
        <div formGroupName="mileStoneInformation">
          <div class="form-row">
            <div class="form-group form-group-sm row col-24">
              <label class="col-form-label col col-lg-4 pr-1 text-right">xNCI Status:</label>
              <div class="col col-lg-4 pl-0 pl-lg-1">
                <input type="text" class="form-control form-control-sm" formControlName="status" [readonly]="true">
              </div>
              <label class="col-form-label col col-lg-4 pr-1 text-right">Region</label>
              <div class="col col-lg-4 pl-0 pl-lg-1">
                <dx-select-box [items]="regionList" formControlName="region"
                               displayExpr="rgnDes" valueExpr="rgnId"
                               [searchEnabled]="true" [searchExpr]="['rgnDes']"
                               searchMode="startswith"></dx-select-box>
              </div>
              <label class="col-form-label col col-lg-4 pr-1 text-right" [ngClass]="{ 'text-danger': !isDisconnect }">Access City Name / Site Code</label>
              <div class="col col-lg-4 pl-0 pl-lg-1">
                <dx-select-box [items]="accessCityNameList" formControlName="accessCityName"
                               displayExpr="accsCtyNmeSiteCd" valueExpr="accsCtySiteId"
                               [searchEnabled]="true" [searchExpr]="['accsCtyNmeSiteCd']"
                               searchMode="startswith"
                               (onValueChanged)="setAccessCityName($event)">
                </dx-select-box>
                <app-form-control-validation [control]="mileStoneInformationForm.controls.accessCityName" [sourceName]="'Access City Name / Site Code'"></app-form-control-validation>
              </div>
            </div>
            <div class="form-group form-group-sm row col-24">
              <label class="col-form-label col col-lg-4 pr-1 text-right">Submit Date:</label>
              <div class="col col-lg-4 pl-0 pl-lg-1">
                <input type="text" class="form-control form-control-sm" formControlName="submitDate" />
              </div>
              <label class="col-form-label col col-lg-4 pr-1 text-right">Customer Commit Date:</label>
              <div class="col col-lg-4 pl-0 pl-lg-1">
                <input type="text" class="form-control form-control-sm" formControlName="customerCommitDate" />
              </div>
              <label class="col-form-label col col-lg-4 pr-1 text-right">Customer Want Date:</label>
              <div class="col col-lg-4 pl-0 pl-lg-1">
                <input type="text" class="form-control form-control-sm" formControlName="customerWantDate" />
              </div>
            </div>
            <div class="form-group form-group-sm row col-24">
              <label class="col-form-label col col-lg-4 pr-1 text-right">Validate Date:</label>
              <div class="col col-lg-4 pl-0 pl-lg-1">
                <dx-date-box type="date" dateSerializationFormat="yyyy-MM-dd"
                             [acceptCustomValue]="false"
                             displayFormat="MMM/dd/yyyy"
                             width="100%"
                             formControlName="validatedDate"
                             pickerType="calendar"
                             [useMaskBehavior]="true">
                </dx-date-box>
              </div>
              <label class="col-form-label col col-lg-4 pr-1 text-right">Vendor Sent Date:</label>
              <div class="col col-lg-4 pl-0 pl-lg-1">
                <dx-date-box type="date" dateSerializationFormat="yyyy-MM-dd"
                  [acceptCustomValue]="false"
                  displayFormat="MMM/dd/yyyy"
                  width="100%"
                  formControlName="orderSentToVendorDate"
                  pickerType="calendar"
                  [useMaskBehavior]="true">
                </dx-date-box>
              </div>
              <label class="col-form-label col col-lg-4 pr-1 text-right">Vendor Acknowledged Date:</label>
              <div class="col col-lg-4 pl-0 pl-lg-1">
                <dx-date-box type="date" dateSerializationFormat="yyyy-MM-dd"
                  [acceptCustomValue]="false"
                  displayFormat="MMM/dd/yyyy"
                  width="100%"
                  formControlName="orderAcknowledgedDate"
                  pickerType="calendar"
                  [useMaskBehavior]="true">
                </dx-date-box>
              </div>
            </div>
            <div *ngIf="!isDisconnect" class="form-group form-group-sm row col-24">
              <label class="col-form-label col col-lg-4 pr-1 text-right">Target Delivery Date:</label>
              <div class="col col-lg-4 pl-0 pl-lg-1">
                <dx-date-box type="date" dateSerializationFormat="yyyy-MM-dd"
                             [acceptCustomValue]="false"
                             displayFormat="MMM/dd/yyyy"
                             width="100%"
                             formControlName="targetDeliveryDate"
                             pickerType="calendar"
                             [useMaskBehavior]="true"
                             (onValueChanged)="onTargetDeliveryDateChanged($event)">
                </dx-date-box>
              </div>
              <label class="col-form-label col col-lg-4 pr-1 text-right">Target Delivery Date Received:</label>
              <div class="col col-lg-4 pl-0 pl-lg-1">
                <dx-date-box type="date" dateSerializationFormat="yyyy-MM-dd"
                             [acceptCustomValue]="false"
                             displayFormat="MMM/dd/yyyy"
                             width="100%"
                             formControlName="targetDeliveryDateReceived"
                             pickerType="calendar"
                             [useMaskBehavior]="true">
                </dx-date-box>
              </div>
            </div>
            <div *ngIf="!isDisconnect" class="form-group form-group-sm row col-24">
              <label class="col-form-label col col-lg-4 pr-1 text-right">Access Delivery Date:</label>
              <div class="col col-lg-4 pl-0 pl-lg-1">
                <dx-date-box type="date" dateSerializationFormat="yyyy-MM-dd"
                             [acceptCustomValue]="false"
                             displayFormat="MMM/dd/yyyy"
                             width="100%"
                             formControlName="accessDeliveryDate"
                             pickerType="calendar"
                             [useMaskBehavior]="true"
                             (onValueChanged)="onAccessDeliveryDateChanged($event)">
                </dx-date-box>
              </div>
              <label class="col-form-label col col-lg-4 pr-1 text-right">Vendor Term:</label>
              <div class="col col-lg-4 pl-0 pl-lg-1">
                <dx-select-box [dataSource]="custContractLengthList" formControlName="vendorContractTerm"
                               displayExpr="custCntrcLgthDes" valueExpr="custCntrcLgthId"
                               [searchEnabled]="true" [searchExpr]="['custCntrcLgthDes']"
                               searchMode="startswith">
                </dx-select-box>
              </div>
              <label class="col-form-label col col-lg-4 pr-1 text-right">Vendor Term Start Date:</label>
              <div class="col col-lg-4 pl-0 pl-lg-1">
                <dx-date-box type="date" dateSerializationFormat="yyyy-MM-dd"
                             [acceptCustomValue]="false"
                             displayFormat="MMM/dd/yyyy"
                             width="100%"
                             formControlName="vendorContractStartDate"
                             pickerType="calendar"
                             [useMaskBehavior]="true">
                </dx-date-box>
              </div>
            </div>
            <div *ngIf="!isDisconnect" class="form-group form-group-sm row col-24">
              <label class="col-form-label col col-lg-4 pr-1 text-right">Access Acceptance Date:</label>
              <div class="col col-lg-4 pl-0 pl-lg-1">
                <dx-date-box type="date" dateSerializationFormat="yyyy-MM-dd"
                             [acceptCustomValue]="false"
                             displayFormat="MMM/dd/yyyy"
                             width="100%"
                             formControlName="accessAcceptDate"
                             pickerType="calendar"
                             [useMaskBehavior]="true">
                </dx-date-box>
              </div>
            </div>
            <div *ngIf="!isDisconnect" class="form-group form-group-sm row col-24">
              <label class="col-form-label col col-lg-4 pr-1 text-right">Bill Clear/Install Date:</label>
              <div class="col col-lg-4 pl-0 pl-lg-1">
                <dx-date-box type="date" dateSerializationFormat="yyyy-MM-dd"
                             [acceptCustomValue]="false"
                             displayFormat="MMM/dd/yyyy"
                             width="100%"
                             formControlName="billClearInstallDate"
                             pickerType="calendar"
                             [useMaskBehavior]="true"
                             (onValueChanged)="onBillClearIntallDateChanged($event)">
                </dx-date-box>
              </div>
              <label class="col-form-label col col-lg-4 pr-1 text-right">Customer Term:</label>
              <div class="col col-lg-4 pl-0 pl-lg-1">
                <input type="text" class="form-control form-control-sm" formControlName="customerContractTerm" />
              </div>
              <label class="col-form-label col col-lg-4 pr-1 text-right">Customer Term Start Date:</label>
              <div class="col col-lg-4 pl-0 pl-lg-1">
                <dx-date-box type="date" dateSerializationFormat="yyyy-MM-dd"
                             [acceptCustomValue]="false"
                             displayFormat="MMM/dd/yyyy"
                             width="100%"
                             formControlName="customerContractStartDate"
                             pickerType="calendar"
                             [useMaskBehavior]="true">
                </dx-date-box>
              </div>
            </div>



            <div *ngIf="isDisconnect" class="form-group form-group-sm row col-24">
              <label class="col-form-label col col-lg-4 pr-1 text-right">Vendor Confirmed Disconnect Date:</label>
              <div class="col col-lg-4 pl-0 pl-lg-1">
                <dx-date-box type="date" dateSerializationFormat="yyyy-MM-dd"
                             [acceptCustomValue]="false"
                             displayFormat="MMM/dd/yyyy"
                             width="100%"
                             formControlName="vendorConfirmedDisconnectDate"
                             pickerType="calendar"
                             [useMaskBehavior]="true"
                             (onValueChanged)="onVendorConfirmedDisconnectDateChanged($event)">
                </dx-date-box>
              </div>
              <label class="col-form-label col col-lg-4 pr-1 text-right">Disconnect Completed Date:</label>
              <div class="col col-lg-4 pl-0 pl-lg-1">
                <dx-date-box type="date" dateSerializationFormat="yyyy-MM-dd"
                             [acceptCustomValue]="false"
                             displayFormat="MMM/dd/yyyy"
                             width="100%"
                             formControlName="disconnectCompletedDate"
                             pickerType="calendar"
                             [useMaskBehavior]="true">
                </dx-date-box>
              </div>
            </div>

            <div class="form-group form-group-sm row col-24">
              <label class="col-form-label col col-lg-4 pr-1 text-right">Closed Date:</label>
              <div class="col col-lg-4 pl-0 pl-lg-1">
                <dx-date-box type="date" dateSerializationFormat="yyyy-MM-dd"
                             [acceptCustomValue]="false"
                             displayFormat="MMM/dd/yyyy"
                             width="100%"
                             formControlName="closedDate"
                             pickerType="calendar"
                             [useMaskBehavior]="true"
                             (onValueChanged)="onClosedDateChanged($event)">
                </dx-date-box>
                <span *ngIf="closedDateError?.length > 0" class="form-text text-danger">{{ closedDateError }}</span>
              </div>
              <label class="col-form-label col col-lg-4 pr-1 text-right"></label>
              <div class="col col-lg-4 pl-0 pl-lg-1">
              </div>
              <label *ngIf="isCancel" class="col-form-label col col-lg-4 pr-1 text-right">Vendor Cancellation Date:</label>
              <div *ngIf="isCancel" class="col col-lg-4 pl-0 pl-lg-1">
                <dx-date-box type="date" dateSerializationFormat="yyyy-MM-dd"
                             [acceptCustomValue]="false"
                             displayFormat="MMM/dd/yyyy"
                             width="100%"
                             formControlName="vendorCancellationDate"
                             pickerType="calendar"
                             [useMaskBehavior]="true">
                </dx-date-box>
              </div>

            </div>

            <div class="form-group form-group-sm row col-24">
              <label class="col-form-label col col-lg-4 pr-1 text-right" style="padding-left:100px">NRM Update:</label>
              <div class="col-8 pl-0 pl-lg-3">

                <!--{{nrmupdate.value}}
              <dx-check-box [(value)]="value" (onValueChanged)="handleValueChange($event)" [(name)]="nrmupdate"></dx-check-box>-->
                <dx-check-box (onValueChanged)="handleValueChange($event)" formControlName="nrmupdate"></dx-check-box>
                <!--<dx-check-box [(value)]="nrmupdate" formControlName="nrmupdate"></dx-check-box>-->
              </div>

            </div>
            <!--<div>
            <dx-check-box formControlName="nrmupdate"
                          text="NRM Update"
                          (onValueChanged)="handleValueChange($event)">
            </dx-check-box>
          </div>-->
          </div>
        </div>
      </mat-expansion-panel>
    </mat-accordion>
    <!-- STDI -->
    <mat-accordion>
      <mat-expansion-panel [expanded]="false" class="mb-2">
        <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
          <mat-panel-title><h6>STDI</h6></mat-panel-title>
        </mat-expansion-panel-header>
        <div class="row" formGroupName="stdi">
          <div class="col-9 pr-2">
            <div class="form-row">
              <div class="form-group form-group-sm row col-24">
                <label class="col-form-label col col-lg-8 pr-1 text-right">Standard Interval</label>
                <div class="col col-lg-16 pl-0 pl-lg-1">
                  <dx-date-box type="date" dateSerializationFormat="yyyy-MM-dd"
                               [acceptCustomValue]="false"
                               displayFormat="MM/dd/yyyy"
                               width="100%"
                               [useMaskBehavior]="true"
                               formControlName="standardInterval">
                  </dx-date-box>
                </div>
              </div>
              <div class="form-group form-group-sm row col-24">
                <label class="col-form-label col col-lg-8 pr-1 text-right">Reason Description</label>
                <div class="col col-lg-16 pl-0 pl-lg-1">
                  <dx-select-box [items]="stdiList" formControlName="reasonDescription"
                                 displayExpr="description" valueExpr="value"
                                 [searchEnabled]="true" [searchExpr]="['description']"
                                 searchMode="startswith"></dx-select-box>
                </div>
              </div>
            </div>
          </div>
          <div class="col-12 pl-2">
            <div class="form-row">
              <div class="form-group form-group-sm row col-24">
                <label class="col-form-label col col-lg-4 pr-1 text-right">Comments</label>
                <div class="col col-lg-20 pl-0 pl-lg-1">
                  <textarea class="form-control form-control-sm" rows="4" formControlName="comments" maxlength="500"></textarea>
                  <span class="form-text">{{ 500 - form.get("stdi.comments").value?.length }} characters left</span>
                </div>
              </div>
            </div>
          </div>
          <div class="col-3 d-flex align-items-center justify-content-center">
            <button class="btn btn-sm btn-primary" (click)="saveStdi($event)">Save STDI Info</button>
          </div>
        </div>
        <div class="row">
          <div class="col">
            <dx-data-grid [dataSource]="stdiReasonList"
                          [wordWrapEnabled]="true" [rowAlternationEnabled]="true"
                          [showBorders]="true" [columnAutoWidth]="true">
              <dxo-sorting mode="multiple"></dxo-sorting>
              <dxo-paging [pageSize]="50"></dxo-paging>
              <dxo-pager [showPageSizeSelector]="true" [allowedPageSizes]="[10, 25, 50, 100]"></dxo-pager>
              <dxo-column-fixing [enabled]="true"></dxo-column-fixing>
              <dxo-scrolling mode="standard" useNative="false"></dxo-scrolling>

              <dxi-column dataField="stdiDt" caption="Interval Date" dataType="date"></dxi-column>
              <dxi-column dataField="stdiReasDes" caption="Interval Reason" dataType="string"></dxi-column>
              <dxi-column dataField="ccd" caption="CCD" dataType="date"></dxi-column>
              <dxi-column dataField="creatByUserFullNme" caption="Created By" dataType="string"></dxi-column>
              <dxi-column dataField="creatDt" caption="Created Date" dataType="string" cellTemplate="dateTimeTemplate"></dxi-column>
              <dxi-column dataField="cmntTxt" caption="Comments" dataType="string"></dxi-column>
              <div *dxTemplate="let cell of 'dateTimeTemplate'">
                <span class="d-block">{{ cell.text | date: 'MM/dd/yyyy' }}</span>
                <span class="d-block">{{ cell.text | date: 'hh:mm a' }}</span>
              </div>
            </dx-data-grid>
          </div>
        </div>
      </mat-expansion-panel>
    </mat-accordion>
    <!-- M5/CTN Notes -->
    <mat-accordion>
      <mat-expansion-panel [expanded]="false" class="mb-2">
        <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
          <mat-panel-title><h6>M5 #/CTN Notes</h6><br /><div class="form-group form-group-sm row col-16 mb-0"><label class="mb-0">{{lastNoteBy}}</label></div></mat-panel-title>
        </mat-expansion-panel-header>
        <div class="row" formGroupName="notes">
          <div class="col-20 pr-2">
            <div class="form-row">
              <div class="form-group form-group-sm row col-24">
                <label class="col-form-label col col-lg-3 pr-1 text-right">Notes:</label>
                <div class="col col-lg-21 pl-0 pl-lg-1">
                  <textarea class="form-control form-control-sm" rows="5" formControlName="description" maxlength="1000"></textarea>
                  <span class="form-text">{{ 1000 - form.get("notes.description").value?.length }} characters left</span>
                  <dx-check-box formControlName="isInternal"
                                text="Is Internal?">
                  </dx-check-box>
                </div>
              </div>
            </div>
          </div>
          <!--<div class="col-4 d-flex align-items-center justify-content-center">
          <button class="btn btn-sm btn-primary" (click)="saveOrderNotes($event)">Save Notes</button>
        </div>-->
        </div>
        <div class="row">
          <div class="col">
            <dx-data-grid [dataSource]="noteList"
                          [wordWrapEnabled]="true" [rowAlternationEnabled]="true"
                          [showBorders]="true" [columnAutoWidth]="true">
              <dxo-sorting mode="multiple"></dxo-sorting>
              <dxo-column-fixing [enabled]="true"></dxo-column-fixing>
              <dxo-scrolling mode="standard" useNative="false"></dxo-scrolling>
              <dxo-paging [pageSize]="10"></dxo-paging>
              <dxo-pager [showPageSizeSelector]="true" [allowedPageSizes]="[10, 25, 50, 100]"></dxo-pager>

              <dxi-column dataField="nteTypeDes" caption="Note Type" dataType="string"></dxi-column>
              <dxi-column dataField="nteTxt" caption="Note" dataType="string" cellTemplate="noteTemplate"></dxi-column>
              <dxi-column dataField="creatByUserFullName" caption="Created By" dataType="string"></dxi-column>
              <dxi-column dataField="creatDt" caption="Created Date" dataType="datetime" cellTemplate="dateTimeTemplate"></dxi-column>
              <div *dxTemplate="let cell of 'dateTimeTemplate'">
                <span class="d-block">{{ cell.text | date: 'MM/dd/yyyy' }}</span>
                <span class="d-block">{{ cell.text | date: 'hh:mm a' }}</span>
              </div>
              <div *dxTemplate="let cell of 'noteTemplate'">
                <div [innerHtml]="cell.value"></div>
              </div>
            </dx-data-grid>
          </div>
        </div>
      </mat-expansion-panel>
    </mat-accordion>
    <!-- Vendor Access Cost Information -->
    <!-- SHOULD HAVE CONDITION OF IF showVendorAccessCost -->
    <mat-accordion *ngIf="showVendorAccessCost || showVendorAdditionalCost">
      <mat-expansion-panel [expanded]="false" class="mb-2">
        <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
          <mat-panel-title><h6>Vendor Access Cost Information</h6></mat-panel-title>
        </mat-expansion-panel-header>
        <div *ngIf="showVendorAccessCost">
          <dx-data-grid class="mb-2" [dataSource]="vendorAccessCostInformationList"
                        [wordWrapEnabled]="true" [rowAlternationEnabled]="true"
                        [showBorders]="true" [columnAutoWidth]="true">
            <dxo-sorting mode="multiple"></dxo-sorting>
            <dxo-paging [pageSize]="50"></dxo-paging>
            <dxo-pager [showPageSizeSelector]="true" [allowedPageSizes]="[10, 25, 50, 100]"></dxo-pager>
            <dxo-column-fixing [enabled]="true"></dxo-column-fixing>
            <dxo-scrolling mode="standard" showScrollbar="always" useNative="false"></dxo-scrolling>
            <dxi-column dataField="preQualSiteID" caption="PreQual Site ID" dataType="string"></dxi-column>
            <dxi-column dataField="preQualLineItem" caption="PreQual Line Item" dataType="string"></dxi-column>
            <dxi-column dataField="preQualExpiration" caption="PreQual Expiration" dataType="date" cellTemplate="dateTemplate"></dxi-column>
            <dxi-column dataField="currency" caption="Quoted Currency" dataType="string"></dxi-column>
            <dxi-column dataField="vendorRAWMRCQuote" caption="Vendor Raw MRC Quote" dataType="string"></dxi-column>
            <dxi-column dataField="vendorRAWNRCQuote" caption="Vendor Raw NRC Quote" dataType="string"></dxi-column>
            <!--<dxi-column dataField="" caption="Revised Vendor Raw Cost" dataType="string"></dxi-column>-->
            <dxi-column dataField="conversionPercentageQty" caption="Conversion Percentage Quantity" dataType="string"></dxi-column>
            <dxi-column dataField="markupPercentageQty" caption="Make Up Percentage Quantity" dataType="string"></dxi-column>
            <dxi-column dataField="taxPercentageQty" caption="Tax Percentage Quantity" dataType="string"></dxi-column>
            <dxi-column dataField="bearerChargeAmt" caption="Bearer Charge Amount" dataType="string"></dxi-column>
            <dxi-column dataField="additionalMRCAmt" caption="Additional MRC Amount" dataType="string"></dxi-column>
            <dxi-column dataField="calculatedRateMRC" caption="Calculated Rate MRC (USD)" dataType="string"></dxi-column>
            <dxi-column dataField="calculatedRateNRC" caption="Calculated Rate NRC (USD)" dataType="string"></dxi-column>
            <dxi-column dataField="calculatedRateMRCCurrency" caption="Calculated Rate MRC (Currency)" dataType="string"></dxi-column>
            <dxi-column dataField="calculatedRateNRCCurrency" caption="Calculated Rate NRC (Currency)" dataType="string"></dxi-column>
            <!--<dxi-column dataField="" caption="Customer Term" dataType="string"></dxi-column>-->
            <dxi-column dataField="vendorTerm" caption="Vendor Term" dataType="string"></dxi-column>
            <dxi-column dataField="vendorNme" caption="Access (Vendor)" dataType="string"></dxi-column>
            <div *dxTemplate="let cell of 'dateTemplate'">
              <span class="d-block">{{ cell.text | date: 'MMM/dd/yyyy' }}</span>
            </div>
          </dx-data-grid>
          <!--New Fields-->
          <div *ngIf="vendorAccessCostInformationList.length > 0" formGroupName="vedorAccessCostInformation">
            <div class="form-group form-group-sm row col-24">
              <label class="col-form-label col col-lg-3 pr-1 text-right">Revised Quoted Currency:</label>
              <div class="col col-lg-3 pl-0 pl-lg-1">
                <dx-select-box [dataSource]="currencyList" formControlName="revisedQuotedCurrency"
                               displayExpr="curNme" valueExpr="curId"
                               [searchEnabled]="true" [searchExpr]="['curNme']"
                               searchMode="startswith">
                </dx-select-box>
                <!--<input type="text" class="form-control form-control-sm" formControlName="revisedQuotedCurrency" />-->
              </div>
              <label class="col-form-label col col-lg-3 pr-1 text-right">Revised Vendor Raw MRC:</label>
              <div class="col col-lg-3 pl-0 pl-lg-1">
                <dx-number-box formControlName="revisedVendorRawMrc" format="###0.##"></dx-number-box>
                <!--<input type="text" class="form-control form-control-sm" formControlName="revisedVendorRawMrc" />-->
              </div>
              <label class="col-form-label col col-lg-3 pr-1 text-right">Revised Vendor Raw NRC:</label>
              <div class="col col-lg-3 pl-0 pl-lg-1">
                <dx-number-box formControlName="revisedVendorRawNrc" format="###0.##"></dx-number-box>
                <!--<input type="text" class="form-control form-control-sm" formControlName="revisedVendorRawNrc" />-->
              </div>
              <label class="col-form-label col col-lg-3 pr-1 text-right">Revised Vendor Term:</label>
              <div class="col col-lg-3 pl-0 pl-lg-1">
                <dx-select-box [dataSource]="custContractLengthList" formControlName="revisedVendorTerm"
                               displayExpr="custCntrcLgthDes" valueExpr="custCntrcLgthId"
                               [searchEnabled]="true" [searchExpr]="['custCntrcLgthDes']"
                               searchMode="startswith">
                </dx-select-box>
                <!--<input type="text" class="form-control form-control-sm" formControlName="revisedVendorTerm" />-->
              </div>
            </div>
            <div class="form-group form-group-sm row col-24">
              <label class="col-form-label col col-lg-3 pr-1 text-right"></label>
              <div class="col col-lg-3 pl-0 pl-lg-1">
                <button type="button" class="btn btn-sm btn-primary btn-block" (click)="saveRevisedVendorDetails()">
                  Save
                </button>
              </div>
            </div>
          </div>
          <dx-data-grid class="mb-2" [dataSource]="vendorAccessCostList"
                        [wordWrapEnabled]="true" [rowAlternationEnabled]="true"
                        [showBorders]="true" [columnAutoWidth]="true">
            <dxo-sorting mode="multiple"></dxo-sorting>
            <dxo-paging [pageSize]="50"></dxo-paging>
            <dxo-pager [showPageSizeSelector]="true" [allowedPageSizes]="[10, 25, 50, 100]"></dxo-pager>
            <dxo-column-fixing [enabled]="true"></dxo-column-fixing>
            <dxo-scrolling mode="standard" showScrollbar="always" useNative="false"></dxo-scrolling>

            <dxi-column dataField="vndrCktId" caption="Vendor Circuit ID" dataType="string"></dxi-column>
            <dxi-column dataField="bndlCd" caption="Bundle" dataType="boolean"></dxi-column>
            <dxi-column dataField="qotNbr" caption="Quote Number" dataType="string"></dxi-column>
            <dxi-column dataField="vndrOrdrNbr" caption="Vendor Order Number" dataType="string"></dxi-column>
            <dxi-column dataField="vndrOrdrNbr" caption="Cost For" dataType="string" cellTemplate="costForTemplate"></dxi-column>
            <dxi-column dataField="vndrMrcAmt" caption="MRC" dataType="string" cellTemplate="mrcAmtTemplate"></dxi-column>
            <dxi-column dataField="vndrNrcAmt" caption="NRC" dataType="string" cellTemplate="nrcAmtTemplate"></dxi-column>
            <dxi-column dataField="taxRtPctQty" caption="Tax Rate (%)" dataType="string" cellTemplate="taxRateTemplate"></dxi-column>
            <dxi-column dataField="vndrCurId" caption="Currency" dataType="string" cellTemplate="currencyTemplate"></dxi-column>
            <dxi-column dataField="vndrMrcInUsdAmt" caption="MRC TOTAL (USD)" dataType="string" cellTemplate="mrcInUsdTemplate"></dxi-column>
            <dxi-column dataField="vndrNrcInUsdAmt" caption="NRC TOTAL (USD)" dataType="string" cellTemplate="nrcInUsdTemplate"></dxi-column>
            <div *dxTemplate="let cell of 'costForTemplate'">
              <div class="row">
                <div class="col-24">
                  Vendor
                </div>
                <div class="col-24">
                  ASR
                </div>
                <div class="col-24">
                  Access
                </div>
              </div>
            </div>
            <div *dxTemplate="let cell of 'mrcAmtTemplate'">
              <div class="row">
                <div class="col-24">
                  $ {{ (cell.data.vndrMrcAmt || 0) | number:'1.2-2' }}
                </div>
                <div class="col-24">
                  $ {{ (cell.data.asrMrcAty || 0) | number:'1.2-2' }}
                </div>
                <div class="col-24">
                  $ {{ (cell.data.accsCustMrcAmt || 0) | number:'1.2-2' }}
                </div>
              </div>
            </div>
            <div *dxTemplate="let cell of 'nrcAmtTemplate'">
              <div class="row">
                <div class="col-24">
                  $ {{ (cell.data.vndrNrcAmt || 0) | number:'1.2-2' }}
                </div>
                <div class="col-24">
                  $ {{ (cell.data.asrNrcAmt || 0) | number:'1.2-2' }}
                </div>
                <div class="col-24">
                  $ {{ (cell.data.accsCustNrcAmt || 0) | number:'1.2-2' }}
                </div>
              </div>
            </div>
            <div *dxTemplate="let cell of 'taxRateTemplate'">
              {{ (cell.data.taxRtPctQty || 0) | number:'1.2-2' }}
            </div>
            <div *dxTemplate="let cell of 'currencyTemplate'">
              <div class="row">
                <div class="col-24">
                  {{ cell.data.vndrCurNme }}&nbsp;
                </div>
                <div class="col-24">
                  {{ cell.data.asrCurNme }}&nbsp;
                </div>
                <div class="col-24">
                  {{ cell.data.accsCustCurNme }}&nbsp;
                </div>
              </div>
            </div>
            <div *dxTemplate="let cell of 'mrcInUsdTemplate'">
              <div class="row">
                <div class="col-24">
                  $ {{ (cell.data.vndrMrcInUsdAmt || 0) | number:'1.2-2' }}
                </div>
                <div class="col-24">
                  $ {{ (cell.data.asrMrcInUsdAmt || 0) | number:'1.2-2' }}
                </div>
                <div class="col-24">
                  $ {{ (cell.data.accsCustMrcInUsdAmt || 0) | number:'1.2-2' }}
                </div>
              </div>
            </div>
            <div *dxTemplate="let cell of 'nrcInUsdTemplate'">
              <div class="row">
                <div class="col-24">
                  $ {{ (cell.data.vndrNrcInUsdAmt || 0) | number:'1.2-2' }}
                </div>
                <div class="col-24">
                  $ {{ (cell.data.asrNrcInUsdAmt || 0) | number:'1.2-2' }}
                </div>
                <div class="col-24">
                  $ {{ (cell.data.accsCustNrcInUsdAmt || 0) | number:'1.2-2' }}
                </div>
              </div>
            </div>
          </dx-data-grid>
        </div>

        <app-additional-costs *ngIf="showVendorAdditionalCost" [parent]="this" viewType="NCI" [isTerminatingVendor]="true"></app-additional-costs>
      </mat-expansion-panel>
    </mat-accordion>      

    <!-- Order, Install, Disconnect, Customer, Account Team -->
    <app-m5-details [parent]="this"></app-m5-details>
    <!-- CPE Line Item -->
    <div *ngIf="showCPE">
      <mat-accordion>
        <mat-expansion-panel [expanded]="false" class="mb-2">
          <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
            <mat-panel-title><h6>CPE Line Item</h6></mat-panel-title>
          </mat-expansion-panel-header>
          <dx-data-grid class="mb-2" [dataSource]="fsaOrderCpeLineItemList"
                        [wordWrapEnabled]="true" [rowAlternationEnabled]="true"
                        [showBorders]="true" [columnAutoWidth]="true">
            <dxo-sorting mode="multiple"></dxo-sorting>
            <dxo-column-fixing [enabled]="true"></dxo-column-fixing>
            <dxo-scrolling mode="standard" useNative="false"></dxo-scrolling>
            <dxo-editing mode="row"
                         [allowUpdating]="true"
                         [useIcons]="true">
            </dxo-editing>

            <dxi-column type="buttons" [width]="100">
              <dxi-button name="edit" [visible]="isPending"></dxi-button>
            </dxi-column>
            <dxi-column dataField="deviceId" caption="Device ID" dataType="string" [allowEditing]="false"></dxi-column>
            <dxi-column dataField="manfPartCd" caption="Manufacture Part Code" dataType="string" [allowEditing]="false"></dxi-column>
            <dxi-column dataField="eqptId" caption="Equipment ID" dataType="string" [allowEditing]="false"></dxi-column>
            <dxi-column dataField="mdsDes" caption="Description" dataType="string" [allowEditing]="false"></dxi-column>
            <dxi-column dataField="cntrcTypeId" caption="Contract Type" dataType="string" [allowEditing]="false"></dxi-column>
            <dxi-column dataField="mfrNme" caption="Manufacturer" dataType="string" [allowEditing]="false"></dxi-column>
            <dxi-column dataField="prchOrdrNbr" caption="Purchase Order #" dataType="string" [allowEditing]="false"></dxi-column>
            <dxi-column dataField="prchOrdrBackOrdrShipDt" caption="Order Ship Date to Cust" dataType="date" cellTemplate="dateTimeTemplate" [allowEditing]="false"></dxi-column>
            <dxi-column dataField="cpeVndrNme" caption="Carrier Name" dataType="string" [allowEditing]="false"></dxi-column>
            <dxi-column dataField="shpmtTrkNbr" caption="Ship Track #" dataType="string" [allowEditing]="false"></dxi-column>
            <dxi-column dataField="custDlvryDt" caption="Cust Delivery Date" dataType="date" cellTemplate="dateTimeTemplate"></dxi-column>
            <div *dxTemplate="let cell of 'dateTimeTemplate'">
              <span class="d-block">{{ cell.text | date: 'MM/dd/yyyy' }}</span>
            </div>
          </dx-data-grid>
          <div formGroupName="cpe">
            <div class="form-row">
              <div class="form-group form-group-sm row col-24">
                <label class="col-form-label col col-lg-3 pr-1 text-right">CPE Order Status:</label>
                <div class="col col-lg-3 pl-0 pl-lg-1">
                  <dx-select-box [items]="cpeOrderStatusList" formControlName="cpeOrderStatus"
                                 displayExpr="description" valueExpr="value"
                                 [searchEnabled]="true" [searchExpr]="['description']"
                                 searchMode="startswith"
                                 (onValueChanged)="changeCpeOrderStatus($event)"></dx-select-box>
                </div>
                <label class="col-form-label col col-lg-3 pr-1 text-right">CPE Completion Date:</label>
                <div class="col col-lg-3 pl-0 pl-lg-1">
                  <dx-date-box type="datetime"
                               [acceptCustomValue]="true"
                               displayFormat="MMM/dd/yyyy"
                               width="100%"
                               formControlName="cpeCompletionDate"
                               [value]="cpeCompletionDate"
                               pickerType="calendar"
                               [useMaskBehavior]="true">
                  </dx-date-box>

                  <!--<input type="text" class="form-control form-control-sm" formControlName="cpeCompletionDate">-->
                </div>



              </div>
              <div class="form-group form-group-sm row col-24">
                <label class="col-form-label col col-lg-3 pr-1 text-right">Requisition Amount ($):</label>
                <div class="col col-lg-3 pl-0 pl-lg-1">
                  <input type="text" class="form-control form-control-sm" formControlName="requisitionAmount">
                </div>
                <label class="col-form-label col col-lg-3 pr-1 text-right">CPE Equipment Type:</label>
                <div class="col col-lg-3 pl-0 pl-lg-1">
                  <input type="text" class="form-control form-control-sm" formControlName="cpeEquipmentType">
                </div>
              </div>
            </div>
          </div>
        </mat-expansion-panel>
      </mat-accordion>
    </div>
    <!-- H5 Folder -->
    <mat-accordion *ngIf="!showCPE">
      <mat-expansion-panel [expanded]="false" class="mb-2">
        <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
          <mat-panel-title><h6>H6 Folder</h6></mat-panel-title>
        </mat-expansion-panel-header>
        <div class="row">
          <div class="col-8">
            <dl class="row" *ngIf="!h5Folder">
              <dt class="col-12 pr-2">
                <span class="d-block text-right">Attach H6 Folder:</span>
              </dt>
              <dd class="col-12 pl-2 text-center">
                <div class="col-24 text-center">
                  <button class="btn btn-sm btn-primary" (click)="showH5FolderSearch()">Search</button>
                  <a [routerLink]="['/h5-folder/']" [queryParams]="{ cmd: 'add' }"
                     class="btn btn-sm btn-primary ml-2" role="button">New</a>
                </div>
              </dd>
            </dl>
            <dl class="row" *ngIf="h5Folder">
              <dt class="col-12 pr-2">
                <span class="d-block text-right">H6 Customer ID:</span>
              </dt>
              <dd class="col-12 pl-2">
                <a [routerLink]="['/h5-folder/']" [queryParams]="{ cmd: 'view', h5FoldrId: h5Folder?.h5FoldrId }">{{ h5Folder?.custId }}</a>
              </dd>
              <dt class="col-12 pr-2">
                <span class="d-block text-right">H6 Customer Name:</span>
              </dt>
              <dd class="col-12 pl-2">{{ h5Folder?.custNme }}</dd>
              <dt class="col-12 pr-2">
                <span class="d-block text-right">City:</span>
              </dt>
              <dd class="col-12 pl-2">{{ h5Folder?.custCtyNme }}</dd>
              <dt class="col-12 pr-2">
                <span class="d-block text-right">Country:</span>
              </dt>
              <dd class="col-12 pl-2">{{ h5Folder?.ctryCd }}</dd>
            </dl>
          </div>
          <div class="col-16" formGroupName="h5Folder" *ngIf="isH5FolderSearchShown">
            <h6 class="text-center">Search H6 Folder</h6>
            <div class="form-row">
              <div class="form-group form-group-sm row col-24">
                <label class="col-form-label col col-lg-6 pr-1 text-right">H6 Customer ID:</label>
                <div class="col col-lg-6 pl-0 pl-lg-1">
                  <input type="text" class="form-control form-control-sm" formControlName="h5CustId">
                </div>
                <label class="col-form-label col col-lg-6 pr-1 text-right">City:</label>
                <div class="col col-lg-6 pl-0 pl-lg-1">
                  <input type="text" class="form-control form-control-sm" formControlName="city">
                </div>
              </div>
              <div class="form-group form-group-sm row col-24">
                <label class="col-form-label col col-lg-6 pr-1 text-right">H6 Customer Name:</label>
                <div class="col col-lg-6 pl-0 pl-lg-1">
                  <input type="text" class="form-control form-control-sm" formControlName="h5CustName">
                </div>
                <label class="col-form-label col col-lg-6 pr-1 text-right">Country:</label>
                <div class="col col-lg-6 pl-0 pl-lg-1">
                  <dx-select-box [dataSource]="countryList" formControlName="country"
                                 displayExpr="ctryNme" valueExpr="ctryCd"
                                 [searchEnabled]="true" [searchExpr]="['ctryNme']"
                                 searchMode="startswith">
                  </dx-select-box>
                </div>
              </div>
              <div class="col-24 text-center">
                <button class="btn btn-sm btn-primary" (click)="searchH5Folder()">Search</button>
                <button class="btn btn-sm btn-primary ml-2" (click)="attachH5Folder()"
                        [disabled]="!selectedItemH5FolderKeys.length"
                        *ngIf="h5FolderList?.length > 0">
                  Attach
                </button>
              </div>
            </div>
            <div *ngIf="h5FolderList?.length > 0">
              <dx-data-grid #gridH5Folder id="gridH5Folder" [dataSource]="h5FolderList"
                            keyExpr="h5FoldrId" [showBorders]="true" [wordWrapEnabled]="true"
                            [rowAlternationEnabled]="true" [columnAutoWidth]="true"
                            (onSelectionChanged)="selectionH5FolderChangedHandler($event)">
                <dxo-sorting mode="multiple"></dxo-sorting>
                <dxo-selection mode="single" showCheckBoxesMode="always" selectAllMode="page"></dxo-selection>
                <dxo-paging [pageSize]="10"></dxo-paging>
                <dxo-pager [showPageSizeSelector]="true" [allowedPageSizes]="[25, 50, 100]"></dxo-pager>
                <dxo-scrolling mode="standard" showScrollbar="always" useNative="false"></dxo-scrolling>
                <dxi-column dataField="custId" caption="H6 Cust ID" dataType="string"></dxi-column>
                <dxi-column dataField="custNme" caption="Customer" dataType="string"></dxi-column>
                <dxi-column dataField="custCtyNme" caption="City" dataType="string"></dxi-column>
                <dxi-column dataField="ctryCd" caption="Country" dataType="string">
                  <dxo-lookup [dataSource]="countryList" valueExpr="ctryCd" displayExpr="ctryNme"></dxo-lookup>
                </dxi-column>
                <dxi-column dataField="h5DocCnt" caption="H6 Doc(s)" dataType="string"></dxi-column>
              </dx-data-grid>
            </div>
          </div>
          <div class="col-16" *ngIf="h5Folder">
            <h6 class="text-center">H6 Documents</h6>
            <dx-data-grid [dataSource]="h5DocumentList"
                          [wordWrapEnabled]="true" [rowAlternationEnabled]="true"
                          [showBorders]="true" [columnAutoWidth]="true">
              <dxo-sorting mode="multiple"></dxo-sorting>
              <dxo-paging [pageSize]="50"></dxo-paging>
              <dxo-pager [showPageSizeSelector]="true" [allowedPageSizes]="[10, 25, 50, 100]"></dxo-pager>
              <dxo-column-fixing [enabled]="true"></dxo-column-fixing>
              <dxo-scrolling mode="standard" useNative="false"></dxo-scrolling>

              <dxi-column dataField="fileNme" caption="H6 Document" dataType="string" cellTemplate="h5DocumentTemplate"></dxi-column>
              <dxi-column dataField="fileSizeQtyStr" caption="Size" dataType="string"></dxi-column>
              <dxi-column dataField="creatDt" caption="Date" dataType="date"></dxi-column>
              <dxi-column dataField="creatByUserAdid" caption="Created By" dataType="string"></dxi-column>
              <div *dxTemplate="let cell of 'h5DocumentTemplate'">
                <a href="#" (click)="onH5DocumentClicked($event, cell.data)">{{ cell.text }}</a>
              </div>
            </dx-data-grid>
          </div>
        </div>
      </mat-expansion-panel>
    </mat-accordion>
    <!-- Vendor Order -->
    <div *ngIf="!showCPE && !showBilling">
      <ng-container *ngIf="vendorOrder; then vendorDetails; else vendorSearch"></ng-container>
      <ng-template #vendorDetails>
        <mat-accordion>
          <mat-expansion-panel [expanded]="false" class="mb-2">
            <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
              <mat-panel-title><h6>Vendor Order Details</h6></mat-panel-title>
            </mat-expansion-panel-header>
            <div formGroupName="vendorOrderDetails">
              <div class="form-row">
                <div class="form-group form-group-sm row col-24">
                  <label class="col-form-label col-3 pr-1 text-right">Vendor Order No:</label>
                  <div *ngIf="!isReadonly" class="col-5 pl-0 pl-lg-1">
                    <a [routerLink]="['/vendor/vendor-order/'+vendorOrder.vndrOrdrId]" [queryParams]="{ wg: workGroup }" class="btn btn-sm btn-primary form-control form-control-sm" role="button">VON{{ vendorOrder.vndrOrdrId.toString().padStart(10, '0') }}</a>
                  </div>
                  <div *ngIf="isReadonly" class="col-5 pl-0 pl-lg-1">
                    <button class="btn btn-sm btn-primary form-control form-control-sm" role="button">VON{{ vendorOrder.vndrOrdrId.toString().padStart(10, '0') }}</button>
                  </div>
                  <label class="col-form-label col-3 pr-1 text-right">Vendor Name:</label>
                  <div class="col-6 pl-0 pl-lg-1">
                    <input type="text" class="form-control form-control-sm" formControlName="vendorName" [readonly]="true">
                  </div>
                  <label class="col-form-label col-3 pr-1 text-right">H6 Country:</label>
                  <div class="col-3 pl-0 pl-lg-1">
                    <input type="text" class="form-control form-control-sm" formControlName="country" [readonly]="true">
                  </div>
                </div>
              </div>
              <div class="form-row">
                <div class="form-group form-group-sm row col-24">
                  <div class="col pl-0 pl-lg-1">
                    <dx-check-box text="Do you want to bypass Vendor Order Milestones: (Order sent to Vendor and Vendor Order Acknowledged)" formControlName="bypassVendorOrderCode"></dx-check-box>
                  </div>
                  <label hidden class="col-form-label col col-lg-4 pr-1 text-right text-danger">Access City Name / Site Code</label>
                  <div hidden class="col col-lg-4 pl-0 pl-lg-1">
                    <!-- <dx-select-box [items]="accessCityNameList" displayExpr="accsCtyNmeSiteCd" valueExpr="accsCtySiteId" formControlName="accessCityName"></dx-select-box> -->
                  </div>
                </div>
              </div>
              <dx-data-grid [dataSource]="vendorOrderEmailList"
                            keyExpr="vndrOrdrEmailId"
                            [wordWrapEnabled]="true"
                            [rowAlternationEnabled]="true"
                            [showBorders]="true"
                            [columnAutoWidth]="true"
                            (onRowUpdating)="onEmailUpdating($event)">
                <dxo-sorting mode="multiple"></dxo-sorting>
                <dxo-selection mode="single"></dxo-selection>
                <dxo-scrolling mode="standard" useNative="false"></dxo-scrolling>
                <dxo-editing mode="row"
                             [allowUpdating]="isEditAllowed"
                             [useIcons]="true">
                </dxo-editing>
                <dxi-column dataField="emailTypeDesc" caption="Email Type" dataType="string" [allowEditing]="false" [width]="150"></dxi-column>
                <dxi-column dataField="verNbr" caption="Version" dataType="string" [allowEditing]="false"></dxi-column>
                <dxi-column dataField="emailSubjTxt" caption="Subject" dataType="string" [allowEditing]="false"></dxi-column>
                <dxi-column dataField="vndrOrdrEmailAtchmt" caption="Attachment(s)" cellTemplate="attachmentTemplate" [width]="300" [allowEditing]="false"></dxi-column>
                <dxi-column dataField="creatByUserFullName" caption="Created By" dataType="string" [allowEditing]="false"></dxi-column>
                <dxi-column dataField="modfdByUserFullName" caption="Modified By" dataType="string" [allowEditing]="false"></dxi-column>
                <dxi-column dataField="modfdDt" caption="Last Activity" dataType="date" cellTemplate="lastActivityTemplate" [allowEditing]="false"></dxi-column>
                <dxi-column dataField="emailStatusDesc" caption="Status" dataType="string" [allowEditing]="false"></dxi-column>
                <dxi-column dataField="icon" caption="" cellTemplate="iconTemplate" [width]="25" [allowEditing]="false"></dxi-column>
                <dxi-column dataField="sentToVendorDate" caption="Vendor Sent Date" dataType="date" [allowEditing]="false"></dxi-column>
                <dxi-column dataField="ackByVendorDate" caption="Vendor Ack Date" dataType="date" [width]="120"></dxi-column>
                <dxi-column type="buttons" [width]="100" [visible]="hasEmptyVendorAcknowledgeDate">
                  <dxi-button name="edit" [visible]="isEditAllowed"></dxi-button>
                </dxi-column>
                <div *dxTemplate="let cell of 'lastActivityTemplate'">
                  <span class="d-block">{{ (cell.data.modfdDt != null ? cell.text : cell.data.creatDt) | date: 'MM/dd/yyyy hh:mm a' }}</span>
                </div>
                <div *dxTemplate="let cell of 'dateTimeTemplate'">
                  <span class="d-block">{{ cell.text | date: 'MM/dd/yyyy hh:mm a' }}</span>
                </div>
                <div *dxTemplate="let cell of 'attachmentTemplate'">
                  <div *ngFor="let value of cell.value" class="row">
                    <div class="col-18">
                      {{ value.fileNme }}
                    </div>
                    <div class="col-6">
                      {{ value.fileSizeQty/1000 | number : '1.2-2' }} KB
                    </div>
                  </div>
                </div>
                <div *dxTemplate="let cell of 'iconTemplate'">
                  <i *ngIf="cell.data.icon === 'fa-unlock'" class="fa fa-unlock fa-lg" aria-hidden="true"></i>
                  <i *ngIf="cell.data.icon === 'fa-lock'" class="fa fa-lock fa-lg" aria-hidden="true"></i>
                </div>
              </dx-data-grid>

              <input type="hidden" class="form-control form-control-sm" formControlName="vendorOrderNo">
            </div>
          </mat-expansion-panel>
        </mat-accordion>
      </ng-template>
      <ng-template #vendorSearch>
        <mat-accordion>
          <mat-expansion-panel #searchVendorOrderPanel [expanded]="false" class="mb-2">
            <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
              <mat-panel-title><h6>Search Vendor Order</h6></mat-panel-title>
            </mat-expansion-panel-header>
            <div formGroupName="vendorOrderSearch">
              <div class="row">
                <div class="col-8">
                  <div class="form-row">
                    <div class="form-group form-group-sm row col-24">
                      <label class="col-form-label col col-lg-8 pr-1 text-right">Vendor:</label>
                      <div class="col col-lg-16 pl-0 pl-lg-1">
                        <input type="text" class="form-control form-control-sm" formControlName="vendor" [readonly]="true">
                      </div>
                    </div>
                    <div class="form-group form-group-sm row col-24">
                      <label class="col-form-label col col-lg-8 pr-1 text-right">Vendor Order No:</label>
                      <div class="col col-lg-16 pl-0 pl-lg-1">
                        <input type="text" class="form-control form-control-sm" formControlName="vendorOrderNo">
                      </div>
                    </div>
                    <div class="form-group form-group-sm row col-24">
                      <label class="col-form-label col col-lg-8 pr-1 text-right">H6 Customer ID:</label>
                      <div class="col col-lg-16 pl-0 pl-lg-1">
                        <input type="text" class="form-control form-control-sm" formControlName="customerId">
                      </div>
                    </div>
                    <div class="form-group form-group-sm row col-24">
                      <label class="col-form-label col col-lg-8 pr-1 text-right">M5#/CTN:</label>
                      <div class="col col-lg-16 pl-0 pl-lg-1">
                        <input type="text" class="form-control form-control-sm" formControlName="ctn">
                      </div>
                    </div>
                    <div class="col-24 text-center">
                      <button class="btn btn-sm btn-primary" (click)="searchVendorOrder($event)">Search</button>
                      <a [routerLink]="['/vendor/vendor-order/add']" [queryParams]="{ orderId: orderId, vendor: form.get('vendorOrderSearch.vendor').value, wg: workGroup }" class="btn btn-sm btn-primary ml-2" role="button">New</a>
                    </div>
                  </div>
                </div>
                <div class="col-16">
                  <dx-data-grid [dataSource]="vendorOrderList"
                                [wordWrapEnabled]="true"
                                [rowAlternationEnabled]="true"
                                [showBorders]="true"
                                [columnAutoWidth]="true"
                                (onRowClick)="onVendorOrderRowClick($event)">
                    <dxo-sorting mode="multiple"></dxo-sorting>
                    <dxo-column-fixing [enabled]="true"></dxo-column-fixing>
                    <dxo-scrolling mode="standard" useNative="false"></dxo-scrolling>

                    <dxi-column dataField="vndrOrdrId" caption="Vendor Order No" dataType="string" cellTemplate="vendorOrderNoTemplate"></dxi-column>
                    <dxi-column dataField="trmtgCd" caption="End" dataType="string" cellTemplate="isTerminatingTemplate"></dxi-column>
                    <dxi-column dataField="vendorName" caption="Vendor" dataType="string"></dxi-column>
                    <dxi-column dataField="countryName" caption="Country" dataType="string"></dxi-column>
                    <div *dxTemplate="let cell of 'vendorOrderNoTemplate'">
                      VON{{ cell.value.toString().padStart(10, '0') }}
                    </div>
                    <div *dxTemplate="let cell of 'isTerminatingTemplate'">
                      {{ trmtgCd ? 'Terminating' : 'Originating' }}
                    </div>
                  </dx-data-grid>
                </div>
              </div>
            </div>
          </mat-expansion-panel>
        </mat-accordion>
      </ng-template>
    </div>
    <!-- Vendor Circuit Information -->
    <mat-accordion *ngIf="!showCPE">
      <mat-expansion-panel [expanded]="false" class="mb-2">
        <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
          <mat-panel-title><h6>Vendor Circuit Information</h6></mat-panel-title>
        </mat-expansion-panel-header>
        <div formGroupName="vendorCircuitInformation">
          <div class="form-row">
            <div class="form-group form-group-sm row col-24">
              <label class="col-form-label col col-lg-4 pr-1 text-right">Vendor Order ID:</label>
              <div class="col col-lg-4 pl-0 pl-lg-1">
                <input type="text" class="form-control form-control-sm" formControlName="vendorOrderId" maxlength="100" />
              </div>
              <label class="col-form-label col col-lg-4 pr-1 text-right">Partner/Vendor Circuit ID:</label>
              <div class="col col-lg-4 pl-0 pl-lg-1">
                <input type="text" class="form-control form-control-sm" formControlName="vendorCircuitId" />
              </div>
              <label class="col-form-label col col-lg-4 pr-1 text-right">LEC ID:</label>
              <div class="col col-lg-4 pl-0 pl-lg-1">
                <input type="text" class="form-control form-control-sm" formControlName="lecId" />
              </div>
            </div>
            <div class="form-group form-group-sm row col-24">
              <label class="col-form-label col col-lg-4 pr-1 text-right">VLAN ID:</label>
              <div class="col col-lg-4 pl-0 pl-lg-1">
                <input type="text" class="form-control form-control-sm" formControlName="vlanId" />
              </div>
              <label class="col-form-label col col-lg-4 pr-1 text-right"># of IP Addresses:</label>
              <div class="col col-lg-4 pl-0 pl-lg-1">
                <input type="text" class="form-control form-control-sm" formControlName="noOfIpAddresses" />
              </div>
              <label class="col-form-label col col-lg-4 pr-1 text-right">Routing Protocol:</label>
              <div class="col col-lg-4 pl-0 pl-lg-1">
                <input type="text" class="form-control form-control-sm" formControlName="routingProtocol" />
              </div>
            </div>
            <div class="form-group form-group-sm row col-24">
              <label class="col-form-label col-4 pr-1 text-right">Customer IP Addresses:</label>
              <div class="col-20 pl-0 pl-lg-1">
                <textarea class="form-control form-control-sm" rows="4" formControlName="customerIpAddresses"></textarea>
              </div>
            </div>
            <div class="form-group form-group-sm row col-24">
              <label class="col-form-label col-4 pr-1 text-right">Special Customer Access Details:</label>
              <div class="col-20 pl-0 pl-lg-1">
                <textarea class="form-control form-control-sm" rows="4" formControlName="specialCustomerAccessDetails"></textarea>
                <br/> <br/>
              </div>
            </div>
           
            <div class="form-group form-group-sm row col-24">
              <h6>Vendor Tie Down Information (Dedicated Only)</h6>
              <br/> <br/>
            </div>
            <div class="form-group form-group-sm row col-24">
              <label class="col-form-label col col-lg-4 pr-1 text-right">Cross-connect Provider:</label>
              <div class="col col-lg-4 pl-0 pl-lg-1">
                <input type="text" class="form-control form-control-sm" formControlName="xCnnctPrvdr" />
              </div>
              <label class="col-form-label col col-lg-4 pr-1 text-right">Tie Down Assignments:</label>
              <div class="col col-lg-4 pl-0 pl-lg-1">
                <input type="text" class="form-control form-control-sm" formControlName="tDwnAssn" />
              </div>
              <label class="col-form-label col col-lg-4 pr-1 text-right">Tie Downs Required:</label>
              <div class="col col-lg-4 pl-0 pl-lg-1">
                <input type="text" class="form-control form-control-sm" formControlName="tDwnReq" />
              </div>
              <br/> <br/>
            </div>
          </div>
        </div>
      </mat-expansion-panel>
    </mat-accordion>
    <!-- Initaite ASR -->
    <mat-accordion *ngIf="showFSA && !showCPE">
      <mat-expansion-panel [expanded]="false" class="mb-2">
        <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
          <mat-panel-title><h6>Initiate ASR</h6></mat-panel-title>
        </mat-expansion-panel-header>
        <div formGroupName="asr">
          <div class="form-row">
            <div class="form-group form-group-sm row col-24">
              <label class="col-form-label col col-lg-2 pr-1 text-right">ASR Type:</label>
              <div class="col col-lg-6 pl-0 pl-lg-1">
                <dx-select-box [dataSource]="asrTypeList" formControlName="asrType"
                               displayExpr="asrTypeNme" valueExpr="asrTypeId"
                               [searchEnabled]="true" [searchExpr]="['asrTypeNme']"
                               searchMode="startswith"
                               (onValueChanged)="onAsrTypeChanged($event)">
                </dx-select-box>
              </div>
              <label class="col-form-label col col-lg-2 pr-1 text-right">Orig/Term:</label>
              <div class="col col-lg-14 pl-0 pl-lg-1">
                <dx-radio-group [items]="origTermList"
                                layout="horizontal"
                                formControlName="origTerm">
                </dx-radio-group>
              </div>
              <span class="form-text">SPECIAL INSTRUCTIONS: Please fill in any additional requirements or information including: is MVRF required, reason for maintenance/change order, reuse of provisioning information i.e. router/port, NUA, IP address or Private Line number. We ask for this information to ensure we provision the order to meet customer needs and your requirements.</span>
            </div>
          </div>
          <mat-accordion *ngIf="asrType.value == 1">
            <mat-expansion-panel [expanded]="false" class="mb-2">
              <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
                <mat-panel-title><h6>SPA E Aggregated</h6></mat-panel-title>
              </mat-expansion-panel-header>
              <div class="row" formGroupName="aggregated">
                <div class="form-group form-group-sm row col-24">
                  <label class="col-form-label col col-lg-5 pr-1 text-right">Access City Name &amp; Site Code:</label>
                  <div class="col col-lg-6 pl-0 pl-lg-1">
                    <input type="text" class="form-control form-control-sm" formControlName="accessCityNameSiteCode" />
                  </div>
                  <label class="col-form-label col col-lg-5 pr-1 text-right">IP Node (TOC/Router location &amp; Site Code):</label>
                  <div class="col col-lg-6 pl-0 pl-lg-1">
                    <input type="text" class="form-control form-control-sm" formControlName="ipNode" />
                  </div>
                </div>
                <div class="form-group form-group-sm row col-24">
                  <label class="col-form-label col col-lg-5 pr-1 text-right">Access Bandwidth (not port or service speed):</label>
                  <div class="col col-lg-6 pl-0 pl-lg-1">
                    <dx-select-box [dataSource]="selectedAccessMbList"
                                   formControlName="accessBandwidth"
                                   displayExpr="accsMbDes" valueExpr="accsMbDes"
                                   [searchEnabled]="true" [searchExpr]="['accsMbDes']"
                                   searchMode="startswith">
                    </dx-select-box>
                  </div>
                  <label class="col-form-label col col-lg-5 pr-1 text-right">Transparent:</label>
                  <div class="col col-lg-6 pl-0 pl-lg-1">
                    <dx-radio-group [items]="yesNoList"
                                    [value]="yesNoList[1]"
                                    layout="horizontal"
                                    formControlName="transparent">
                    </dx-radio-group>
                  </div>
                </div>
                <div class="form-group form-group-sm row col-24">
                  <label class="col-form-label col col-lg-5 pr-1 text-right">Partner and Carrier Code (access vendor):</label>
                  <div class="col col-lg-6 pl-0 pl-lg-1">
                    <input type="text" class="form-control form-control-sm" formControlName="partnerCarrierCode" />
                  </div>
                  <label class="col-form-label col col-lg-5 pr-1 text-right">LEC NNI (9 digit numeric value):</label>
                  <div class="col col-lg-6 pl-0 pl-lg-1">
                    <input type="text" class="form-control form-control-sm" formControlName="lecNni" />
                    <div *ngIf="lecNni.invalid && (lecNni.dirty || lecNni.touched || isSubmitted)">
                      <span *ngIf="lecNni.errors.pattern" class="form-text text-danger">LEC NNI must be 9-digit number</span>
                    </div>
                  </div>
                </div>
              </div>
            </mat-expansion-panel>
          </mat-accordion>
          <mat-accordion *ngIf="asrType.value == 2">
            <mat-expansion-panel [expanded]="false" class="mb-2">
              <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
                <mat-panel-title><h6>SPA E Dedicated</h6></mat-panel-title>
              </mat-expansion-panel-header>
              <div class="row" formGroupName="dedicated">
                <div class="form-group form-group-sm row col-24">
                  <label class="col-form-label col col-lg-5 pr-1 text-right">IP Node (TOC/Router location &amp; Site Code):</label>
                  <div class="col col-lg-6 pl-0 pl-lg-1">
                    <input type="text" class="form-control form-control-sm" formControlName="ipNode" />
                  </div>
                  <label class="col-form-label col col-lg-6 pr-1 text-right">Access Bandwidth (not port or service speed):</label>
                  <div class="col col-lg-6 pl-0 pl-lg-1">
                    <dx-select-box [dataSource]="selectedAccessMbList"
                                   formControlName="accessBandwidth"
                                   displayExpr="accsMbDes" valueExpr="accsMbDes"
                                   [searchEnabled]="true" [searchExpr]="['accsMbDes']"
                                   searchMode="startswith">
                    </dx-select-box>
                  </div>
                </div>
                <div class="form-group form-group-sm row col-24">
                  <label class="col-form-label col col-lg-5 pr-1 text-right">Partner and Carrier Code (access vendor):</label>
                  <div class="col col-lg-6 pl-0 pl-lg-1">
                    <input type="text" class="form-control form-control-sm" formControlName="partnerCarrierCode" />
                  </div>
                </div>
              </div>
            </mat-expansion-panel>
          </mat-accordion>
          <mat-accordion *ngIf="asrType.value == 3">
            <mat-expansion-panel [expanded]="false" class="mb-2">
              <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
                <mat-panel-title><h6>TDM</h6></mat-panel-title>
              </mat-expansion-panel-header>
              <div class="row" formGroupName="tdm">
                <div class="form-group form-group-sm row col-24">
                  <label class="col-form-label col col-lg-5 pr-1 text-right">IP Node (TOC/Router location &amp; Site Code):</label>
                  <div class="col col-lg-6 pl-0 pl-lg-1">
                    <input type="text" class="form-control form-control-sm" formControlName="ipNode" />
                  </div>
                  <label class="col-form-label col col-lg-6 pr-1 text-right">Access Bandwidth (not port or service speed):</label>
                  <div class="col col-lg-6 pl-0 pl-lg-1">
                    <dx-select-box [dataSource]="selectedAccessMbList"
                                   formControlName="accessBandwidth"
                                   displayExpr="accsMbDes" valueExpr="accsMbDes"
                                   [searchEnabled]="true" [searchExpr]="['accsMbDes']"
                                   searchMode="startswith">
                    </dx-select-box>
                  </div>
                </div>
                <div class="form-group form-group-sm row col-24">
                  <label class="col-form-label col col-lg-5 pr-1 text-right">Partner and Carrier Code (access vendor):</label>
                  <div class="col col-lg-6 pl-0 pl-lg-1">
                    <input type="text" class="form-control form-control-sm" formControlName="partnerCarrierCode" />
                  </div>
                  <label class="col-form-label col col-lg-6 pr-1 text-right">Entrance Assignment:</label>
                  <div class="col col-lg-6 pl-0 pl-lg-1">
                    <input type="text" class="form-control form-control-sm" formControlName="entranceAssignment" />
                  </div>
                </div>
              </div>
            </mat-expansion-panel>
          </mat-accordion>
          <mat-accordion *ngIf="asrType.value == 4">
            <mat-expansion-panel [expanded]="false" class="mb-2">
              <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
                <mat-panel-title><h6>IPL + IP</h6></mat-panel-title>
              </mat-expansion-panel-header>
              <div class="row" formGroupName="ipl">
                <div class="form-group form-group-sm row col-24">
                  <label class="col-form-label col col-lg-5 pr-1 text-right">IP Node (TOC/Router location &amp; Site Code):</label>
                  <div class="col col-lg-6 pl-0 pl-lg-1">
                    <input type="text" class="form-control form-control-sm" formControlName="ipNode" />
                  </div>
                  <label class="col-form-label col col-lg-5 pr-1 text-right">Access Bandwidth (not port or service speed):</label>
                  <div class="col col-lg-6 pl-0 pl-lg-1">
                    <dx-select-box [dataSource]="selectedAccessMbList"
                                   formControlName="accessBandwidth"
                                   displayExpr="accsMbDes" valueExpr="accsMbDes"
                                   [searchEnabled]="true" [searchExpr]="['accsMbDes']"
                                   searchMode="startswith">
                    </dx-select-box>
                  </div>
                </div>
              </div>
            </mat-expansion-panel>
          </mat-accordion>
          <mat-accordion *ngIf="asrType.value == 5">
            <mat-expansion-panel [expanded]="false" class="mb-2">
              <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
                <mat-panel-title><h6>Off Net</h6></mat-panel-title>
              </mat-expansion-panel-header>
              <div class="row" formGroupName="offnet">
                <div class="form-group form-group-sm row col-24">
                  <label class="col-form-label col col-lg-4 pr-1 text-right">What is the Master VAS M5 #:</label>
                  <div class="col col-lg-6 pl-0 pl-lg-1">
                    <input type="text" class="form-control form-control-sm" formControlName="masterVas" />
                    <div *ngIf="masterVas.invalid && (masterVas.dirty || masterVas.touched || isSubmitted)">
                      <span *ngIf="masterVas.errors.pattern" class="form-text text-danger">Please enter only numbers</span>
                    </div>
                  </div>
                  <label class="col-form-label col col-lg-2 pr-1 text-right">DLCI:</label>
                  <div class="col col-lg-6 pl-0 pl-lg-1">
                    <input type="text" class="form-control form-control-sm" formControlName="dlci" />
                  </div>
                </div>
                <div class="form-group form-group-sm row col-24">
                  <label class="col-form-label col col-lg-4 pr-1 text-right">Does the H1 match the Master VAS:</label>
                  <div class="col col-lg-6 pl-0 pl-lg-1">
                    <dx-radio-group [items]="yesNoList"
                                    [value]="yesNoList[1]"
                                    layout="horizontal"
                                    formControlName="isH1Matched">
                    </dx-radio-group>
                  </div>
                </div>
              </div>
            </mat-expansion-panel>
          </mat-accordion>
          <mat-accordion>
            <mat-expansion-panel [expanded]="false" class="mb-2">
              <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
                <mat-panel-title><h6>Notes</h6></mat-panel-title>
              </mat-expansion-panel-header>
              <div class="form-group form-group-sm row col-24">
                <label class="col-form-label col col-lg-3 pr-1 text-right">Notes:</label>
                <div class="col col-lg-21 pl-0 pl-lg-1">
                  <textarea class="form-control form-control-sm" rows="4" formControlName="notes" maxlength="1000"></textarea>
                  <span class="form-text">{{ 1000 - form.get("asr.notes").value?.length }} characters left</span>
                </div>
              </div>
            </mat-expansion-panel>
          </mat-accordion>
        </div>
        <div *ngIf="!isReadonly" class="form-row text-center">
          <div class="form-group form-group-sm col-12 col-md-4">
            <button type="button" class="btn btn-sm btn-primary btn-block" (click)="asrSubmit()">
              Submit
            </button>
          </div>
        </div>
      </mat-expansion-panel>
    </mat-accordion>
    <!-- NRM -->
    <app-nrm *ngIf="!showCPE && !showBilling && showFSA" [group]="form.controls.nrm" [parent]="this" [orderType]="orderType"></app-nrm>
    <!--CCD History-->
    <mat-accordion *ngIf="showFSA">
      <mat-expansion-panel [expanded]="false" class="mb-1">
        <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
          <mat-panel-title><h6>CCD History</h6></mat-panel-title>
        </mat-expansion-panel-header>
        <dx-data-grid class="mb-3" [dataSource]="ccdList"
                      [wordWrapEnabled]="true" [rowAlternationEnabled]="true"
                      [showBorders]="true" [columnAutoWidth]="true">
          <dxo-sorting mode="multiple"></dxo-sorting>
          <dxo-column-fixing [enabled]="true"></dxo-column-fixing>
          <dxo-scrolling mode="standard" useNative="false"></dxo-scrolling>

          <dxi-column dataField="ccdOld" caption="Old CCD" dataType="datetime" cellTemplate="oldCcdDtTemplate"></dxi-column>
          <div *dxTemplate="let cell of 'oldCcdDtTemplate'">
            <span class="d-block">{{ cell.text | date: 'MM/dd/yyyy' }}</span>
          </div>
          <dxi-column dataField="ccdNew" caption="New CCD" dataType="datetime" cellTemplate="newCcdDtTemplate"></dxi-column>
          <div *dxTemplate="let cell of 'newCcdDtTemplate'">
            <span class="d-block">{{ cell.text | date: 'MM/dd/yyyy' }}</span>
          </div>
          <dxi-column dataField="reasonPipeSV" caption="Reasons" dataType="string"></dxi-column>
          <dxi-column dataField="note" caption="Note" dataType="string"></dxi-column>
          <dxi-column dataField="createdByDspNme" caption="Changed By" dataType="string"></dxi-column>
          <dxi-column dataField="createdDateTime" caption="Change Date" dataType="datetime" cellTemplate="creatDtTemplate"></dxi-column>
          co
          e=
          <div *dxTemplate="let cell of 'creatDtTemplate'">
            <span class="d-block">{{ cell.text | date: 'MM/dd/yyyy hh:mm aa' }}</span>
          </div>
        </dx-data-grid>
      </mat-expansion-panel>
    </mat-accordion>

    <div class="form-row text-center">
      <div class="form-group form-group-sm col-3">
        <button type="button" class="btn btn-sm btn-secondary btn-block" (click)="cancel()">
          Cancel / Close
        </button>
      </div>
      <div *ngIf="!isOrderComplete && !isClosed && !isReadonly" class="form-group form-group-sm col-3">
        <button type="button" class="btn btn-sm btn-primary btn-block" (click)="submit()" [disabled]="locked">
          Save
        </button>
      </div>
      <div *ngIf="!isOrderComplete && showCPE && !isReadonly" class="form-group form-group-sm col-3">
        <button type="button" class="btn btn-sm btn-primary btn-block" (click)="completeCpe()" [disabled]="locked">
          Complete/Close
        </button>
      </div>
      <div *ngIf="!isOrderComplete && showReturnToGomButton && !isReadonly" class="form-group form-group-sm col-3">
        <button type="button" class="btn btn-sm btn-primary btn-block" (click)="returnToGom()" [disabled]="locked">
          Return to GOM
        </button>
      </div>
      <div *ngIf="!isOrderComplete && (!isClosed && showReturnToSalesButton) && !isReadonly" class="form-group form-group-sm col-3">
        <button type="button" class="btn btn-sm btn-primary btn-block" (click)="returnToSales()" [disabled]="locked">
          Return to Sales
        </button>
      </div>
      <div *ngIf="!isOrderComplete && showClearAcr && !isReadonly" class="form-group form-group-sm col-3">
        <button type="button" class="btn btn-sm btn-primary btn-block" (click)="clearAcrTask()" [disabled]="locked">
          Clear ACR Notification
        </button>
      </div>
      <div *ngIf="!isOrderComplete && showClearRts && !isReadonly" class="form-group form-group-sm col-3">
        <button type="button" class="btn btn-sm btn-primary btn-block" (click)="clearAcrTask()" [disabled]="locked">
          Clear RTS Response Notification
        </button>
      </div>
      <div *ngIf="showClearCcd && !isReadonly" class="form-group form-group-sm col-3">
        <button type="button" class="btn btn-sm btn-primary btn-block" (click)="clearAcrTask()" [disabled]="locked">
          Clear CCD Notification
        </button>
      </div>
      <div *ngIf="!isOrderComplete && showSalesSupportNotes && !isReadonly" class="form-group form-group-sm col-3">
        <button type="button" class="btn btn-sm btn-primary btn-block" (click)="salesSupportNotes()">
          Sales Support Notes
        </button>
      </div>
      <div *ngIf="isBAREditAllowed" class="form-group form-group-sm col-3">
        <button type="button" class="btn btn-sm btn-primary btn-block" (click)="editOrder()">
          Edit Order
        </button>
      </div>
    </div>
  </form>
</div>

<app-validation-summary [errors]="errors" [option]="option.validationSummaryOptions"></app-validation-summary>

<dx-speed-dial-action icon="collapse"
                      label="Collapse all panels"
                      [index]="1"
                      (onClick)="onCollapseClicked()">
</dx-speed-dial-action>

<div class="modal fade" id="logicallis" tabindex="-1" role="dialog" aria-hidden="true">
  <div class="modal-dialog modal-xl" role="document">
    <div class="modal-content">
      <div class="modal-header">
        <h5 class="modal-title">CPE Disconnect Request</h5>
        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
          <span aria-hidden="true">&times;</span>
        </button>
      </div>
      <div class="modal-body">
        <form [formGroup]="logicallis">
          <div class="form-row">
            <div class="form-group form-group-sm row col-24">
              <label class="col-form-label col col-lg-4 pr-1 text-right">Notes:</label>
              <div class="col col-lg-20 pl-0 pl-lg-1">
                <textarea class="form-control form-control-sm" rows="4" formControlName="notes"></textarea>
              </div>
            </div>
          </div>
          <div class="form-row text-center">
            <div class="form-group form-group-sm col-3">
              <button type="button" class="btn btn-sm btn-primary btn-block" (click)="requestToLogicallis()">
                Submit
              </button>
            </div>
          </div>
        </form>
      </div>
    </div>
  </div>
</div>
